gi-gtk4-4.0.12: Gtk 4.x bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gtk.Objects.ApplicationWindow

Contents

- Exported types
- Methods
  - getHelpOverlay
  - getId
  - getShowMenubar
  - new
  - setHelpOverlay
  - setShowMenubar
- Properties
  - showMenubar
- Signals
  - saveState

Description

A `GtkWindow` subclass that integrates with `GtkApplication`.

Notably, `GtkApplicationWindow` can handle an application menubar.

This class implements the `ActionGroup` and `ActionMap` interfaces, to let you add window-specific actions that will be exported by the associated `Application`, together with its application-wide actions. Window-specific actions are prefixed with the “win.” prefix and application-wide actions are prefixed with the “app.” prefix. Actions must be addressed with the prefixed name when referring to them from a menu model.

Note that widgets that are placed inside a `GtkApplicationWindow` can also activate these actions, if they implement the `Actionable` interface.

The settings Settings:gtkShellShowsAppMenu and Settings:gtkShellShowsMenubar tell GTK whether the desktop environment is showing the application menu and menubar models outside the application as part of the desktop shell. For instance, on OS X, both menus will be displayed remotely; on Windows neither will be.

If the desktop environment does not display the menubar, it can be shown in the `GtkApplicationWindow` by setting the ApplicationWindow:showMenubar property to true. If the desktop environment does not display the application menu, then it will automatically be included in the menubar or in the window’s client-side decorations.

See `PopoverMenu` for information about the XML language used by `GtkBuilder` for menu models.

See also: `applicationSetMenubar`.

## A GtkApplicationWindow with a menubar

The code sample below shows how to set up a `GtkApplicationWindow` with a menu bar defined on the `Application`:

### c code

    GtkApplication *app = gtk_application_new ("org.gtk.test", 0);

    GtkBuilder *builder = gtk_builder_new_from_string (
        "<interface>"
        "  <menu id='menubar'>"
        "    <submenu>"
        "      <attribute name='label' translatable='yes'>_Edit</attribute>"
        "      <item>"
        "        <attribute name='label' translatable='yes'>_Copy</attribute>"
        "        <attribute name='action'>win.copy</attribute>"
        "      </item>"
        "      <item>"
        "        <attribute name='label' translatable='yes'>_Paste</attribute>"
        "        <attribute name='action'>win.paste</attribute>"
        "      </item>"
        "    </submenu>"
        "  </menu>"
        "</interface>",
        -1);

    GMenuModel *menubar = G_MENU_MODEL (gtk_builder_get_object (builder, "menubar"));
    gtk_application_set_menubar (GTK_APPLICATION (app), menubar);
    g_object_unref (builder);

    // ...

    GtkWidget *window = gtk_application_window_new (app);

Synopsis

- newtype ApplicationWindow = ApplicationWindow (ManagedPtr ApplicationWindow)
- class (GObject o, IsDescendantOf ApplicationWindow o) => IsApplicationWindow o
- toApplicationWindow :: (MonadIO m, IsApplicationWindow o) => o -> m ApplicationWindow
- applicationWindowGetHelpOverlay :: (HasCallStack, MonadIO m, IsApplicationWindow a) => a -> m (Maybe ShortcutsWindow)
- applicationWindowGetId :: (HasCallStack, MonadIO m, IsApplicationWindow a) => a -> m Word32
- applicationWindowGetShowMenubar :: (HasCallStack, MonadIO m, IsApplicationWindow a) => a -> m Bool
- applicationWindowNew :: (HasCallStack, MonadIO m, IsApplication a) => a -> m ApplicationWindow
- applicationWindowSetHelpOverlay :: (HasCallStack, MonadIO m, IsApplicationWindow a, IsShortcutsWindow b) => a -> Maybe b -> m ()
- applicationWindowSetShowMenubar :: (HasCallStack, MonadIO m, IsApplicationWindow a) => a -> Bool -> m ()
- constructApplicationWindowShowMenubar :: (IsApplicationWindow o, MonadIO m) => Bool -> m (GValueConstruct o)
- getApplicationWindowShowMenubar :: (MonadIO m, IsApplicationWindow o) => o -> m Bool
- setApplicationWindowShowMenubar :: (MonadIO m, IsApplicationWindow o) => o -> Bool -> m ()
- type ApplicationWindowSaveStateCallback = VariantDict -> IO Bool
- afterApplicationWindowSaveState :: (IsApplicationWindow a, MonadIO m) => a -> ((?self :: a) => ApplicationWindowSaveStateCallback) -> m SignalHandlerId
- onApplicationWindowSaveState :: (IsApplicationWindow a, MonadIO m) => a -> ((?self :: a) => ApplicationWindowSaveStateCallback) -> m SignalHandlerId

# Exported types

newtype ApplicationWindow Source #

Memory-managed wrapper type.

Constructors

ApplicationWindow (ManagedPtr ApplicationWindow) |

#### Instances

Instances details

Eq ApplicationWindow Source # |
Instance details Defined in GI.Gtk.Objects.ApplicationWindow Methods (==) :: ApplicationWindow -> ApplicationWindow -> Bool Source # (/=) :: ApplicationWindow -> ApplicationWindow -> Bool Source #
GObject ApplicationWindow Source # |
Instance details Defined in GI.Gtk.Objects.ApplicationWindow
ManagedPtrNewtype ApplicationWindow Source # |
Instance details Defined in GI.Gtk.Objects.ApplicationWindow Methods toManagedPtr :: ApplicationWindow -> ManagedPtr ApplicationWindow Source #
TypedObject ApplicationWindow Source # |
Instance details Defined in GI.Gtk.Objects.ApplicationWindow Methods glibType :: IO GType Source #
HasParentTypes ApplicationWindow Source # |
Instance details Defined in GI.Gtk.Objects.ApplicationWindow
IsGValue (Maybe ApplicationWindow) Source # | Convert `ApplicationWindow` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Gtk.Objects.ApplicationWindow Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe ApplicationWindow -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe ApplicationWindow) Source #
type ParentTypes ApplicationWindow Source # |
Instance details Defined in GI.Gtk.Objects.ApplicationWindow type ParentTypes ApplicationWindow = '[Window, Widget, Object, ActionGroup, ActionMap, Accessible, Buildable, ConstraintTarget, Native, Root, ShortcutManager]

class (GObject o, IsDescendantOf ApplicationWindow o) => IsApplicationWindow o Source #

Type class for types which can be safely cast to `ApplicationWindow`, for instance with `toApplicationWindow`.

#### Instances

Instances details

(GObject o, IsDescendantOf ApplicationWindow o) => IsApplicationWindow o Source # |
Instance details Defined in GI.Gtk.Objects.ApplicationWindow

toApplicationWindow :: (MonadIO m, IsApplicationWindow o) => o -> m ApplicationWindow Source #

Cast to `ApplicationWindow`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

actionAdded, actionEnabledChanged, actionRemoved, actionSetEnabled, actionStateChanged, activate, activateAction, activateDefault, addAction, addActionEntries, addController, addCssClass, addMnemonicLabel, addTickCallback, allocate, announce, bindProperty, bindPropertyFull, changeActionState, childFocus, close, computeBounds, computeExpand, computePoint, computeTransform, contains, createPangoContext, createPangoLayout, destroy, disposeTemplate, dragCheckThreshold, errorBell, forceFloating, freezeNotify, fullscreen, fullscreenOnMonitor, getv, grabFocus, hasAction, hasCssClass, hasDefault, hasFocus, hasGroup, hasVisibleFocus, hide, inDestruction, initTemplate, insertActionGroup, insertAfter, insertBefore, isActive, isAncestor, isDrawable, isFloating, isFocus, isFullscreen, isMaximized, isSensitive, isSuspended, isVisible, keynavFailed, listActions, listMnemonicLabels, lookupAction, map, maximize, measure, minimize, mnemonicActivate, notify, notifyByPspec, observeChildren, observeControllers, pick, present, presentWithTime, queryAction, queueAllocate, queueDraw, queueResize, realize, ref, refSink, removeAction, removeActionEntries, removeController, removeCssClass, removeMnemonicLabel, removeTickCallback, resetProperty, resetRelation, resetState, runDispose, shouldLayout, show, sizeAllocate, snapshotChild, stealData, stealQdata, thawNotify, translateCoordinates, triggerTooltipQuery, unfullscreen, unmap, unmaximize, unminimize, unparent, unrealize, unref, unsetStateFlags, updateNextAccessibleSibling, updatePlatformState, updateProperty, updateRelation, updateState, watchClosure.

#### Getters

getAccessibleId, getAccessibleParent, getAccessibleRole, getActionEnabled, getActionParameterType, getActionState, getActionStateHint, getActionStateType, getAllocatedBaseline, getAllocatedHeight, getAllocatedWidth, getAllocation, getAncestor, getApplication, getAtContext, getBaseline, getBounds, getBuildableId, getCanFocus, getCanTarget, getChild, getChildVisible, getClipboard, getColor, getCssClasses, getCssName, getCursor, getData, getDecorated, getDefaultSize, getDefaultWidget, getDeletable, getDestroyWithParent, getDirection, getDisplay, getFirstAccessibleChild, getFirstChild, getFocus, getFocusChild, getFocusOnClick, getFocusVisible, getFocusable, getFontMap, getFontOptions, getFrameClock, getGravity, getGroup, getHalign, getHandleMenubarAccel, getHasTooltip, getHeight, getHelpOverlay, getHexpand, getHexpandSet, getHideOnClose, getIconName, getId, getLastChild, getLayoutManager, getLimitEvents, getMapped, getMarginBottom, getMarginEnd, getMarginStart, getMarginTop, getMnemonicsVisible, getModal, getName, getNative, getNextAccessibleSibling, getNextSibling, getOpacity, getOverflow, getPangoContext, getParent, getPlatformState, getPreferredSize, getPrevSibling, getPrimaryClipboard, getProperty, getQdata, getRealized, getReceivesDefault, getRenderer, getRequestMode, getResizable, getRoot, getScaleFactor, getSensitive, getSettings, getShowMenubar, getSize, getSizeRequest, getStateFlags, getStyleContext, getSurface, getSurfaceTransform, getTemplateChild, getTitle, getTitlebar, getTooltipMarkup, getTooltipText, getTransientFor, getValign, getVexpand, getVexpandSet, getVisible, getWidth.

#### Setters

setAccessibleParent, setApplication, setCanFocus, setCanTarget, setChild, setChildVisible, setCssClasses, setCursor, setCursorFromName, setData, setDataFull, setDecorated, setDefaultSize, setDefaultWidget, setDeletable, setDestroyWithParent, setDirection, setDisplay, setFocus, setFocusChild, setFocusOnClick, setFocusVisible, setFocusable, setFontMap, setFontOptions, setGravity, setHalign, setHandleMenubarAccel, setHasTooltip, setHelpOverlay, setHexpand, setHexpandSet, setHideOnClose, setIconName, setLayoutManager, setLimitEvents, setMarginBottom, setMarginEnd, setMarginStart, setMarginTop, setMnemonicsVisible, setModal, setName, setOpacity, setOverflow, setParent, setProperty, setReceivesDefault, setResizable, setSensitive, setShowMenubar, setSizeRequest, setStartupId, setStateFlags, setTitle, setTitlebar, setTooltipMarkup, setTooltipText, setTransientFor, setValign, setVexpand, setVexpandSet, setVisible.

## getHelpOverlay

applicationWindowGetHelpOverlay Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationWindow a) |
=> a | `window`: an application window
-> m (Maybe ShortcutsWindow) | Returns: the help overlay associated with the window

Deprecated: (Since version 4.18)`GtkShortcutsWindow` will be removed in GTK 5

Gets the `GtkShortcutsWindow` that is associated with `window`.

See `applicationWindowSetHelpOverlay`.

## getId

applicationWindowGetId Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationWindow a) |
=> a | `window`: an application window
-> m Word32 | Returns: the unique ID for the window, or `0` if the window has not yet been added to an application

Returns the unique ID of the window.

If the window has not yet been added to a `GtkApplication`, returns `0`.

## getShowMenubar

applicationWindowGetShowMenubar Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationWindow a) |
=> a | `window`: an application window
-> m Bool | Returns: True if the window will display a menubar when needed

Returns whether the window will display a menubar for the app menu and menubar as needed.

## new

applicationWindowNew Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplication a) |
=> a | `application`: an application
-> m ApplicationWindow | Returns: a newly created `GtkApplicationWindow`

Creates a new `GtkApplicationWindow`.

## setHelpOverlay

applicationWindowSetHelpOverlay Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationWindow a, IsShortcutsWindow b) |
=> a | `window`: an application window
-> Maybe b | `helpOverlay`: a shortcuts window
-> m () |

Deprecated: (Since version 4.18)`GtkShortcutsWindow` will be removed in GTK 5

Associates a shortcuts window with the application window.

Additionally, sets up an action with the name `win.show-help-overlay` to present it.

The window takes responsibility for destroying the help overlay.

## setShowMenubar

applicationWindowSetShowMenubar Source #

Arguments

:: (HasCallStack, MonadIO m, IsApplicationWindow a) |
=> a | `window`: an application window
-> Bool | `showMenubar`: whether to show a menubar when needed
-> m () |

Sets whether the window will display a menubar for the app menu and menubar as needed.

# Properties

## showMenubar

If this property is true, the window will display a menubar unless it is shown by the desktop shell.

See `applicationSetMenubar`.

If false, the window will not display a menubar, regardless of whether the desktop shell is showing it or not.

constructApplicationWindowShowMenubar :: (IsApplicationWindow o, MonadIO m) => Bool -> m (GValueConstruct o) Source #

Construct a `GValueConstruct` with valid value for the “`show-menubar`” property. This is rarely needed directly, but it is used by `new`.

getApplicationWindowShowMenubar :: (MonadIO m, IsApplicationWindow o) => o -> m Bool Source #

Get the value of the “`show-menubar`” property. When overloading is enabled, this is equivalent to

    get applicationWindow #showMenubar

setApplicationWindowShowMenubar :: (MonadIO m, IsApplicationWindow o) => o -> Bool -> m () Source #

Set the value of the “`show-menubar`” property. When overloading is enabled, this is equivalent to

    set applicationWindow [ #showMenubar := value ]

# Signals

## saveState

type ApplicationWindowSaveStateCallback Source #

Arguments

= VariantDict | `dict`: a dictionary to populate with application window state
-> IO Bool | Returns: true to stop stop further handlers from running

The handler for this signal should persist any application-specific state of `window` into `dict`.

Note that window management state such as maximized, fullscreen, or window size should not be saved as part of this. They are handled by GTK.

See Application::restoreWindow.

Since: 4.24

afterApplicationWindowSaveState :: (IsApplicationWindow a, MonadIO m) => a -> ((?self :: a) => ApplicationWindowSaveStateCallback) -> m SignalHandlerId Source #

Connect a signal handler for the saveState signal, to be run after the default handler. When overloading is enabled, this is equivalent to

    after applicationWindow #saveState callback

By default the object invoking the signal is not passed to the callback. If you need to access it, you can use the implit `?self` parameter. Note that this requires activating the `ImplicitParams` GHC extension.

onApplicationWindowSaveState :: (IsApplicationWindow a, MonadIO m) => a -> ((?self :: a) => ApplicationWindowSaveStateCallback) -> m SignalHandlerId Source #

Connect a signal handler for the saveState signal, to be run before the default handler. When overloading is enabled, this is equivalent to

    on applicationWindow #saveState callback